using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Microsoft.WindowsMobile.Status;

namespace StateAndNotificationsBroker_CS
{
    public partial class Form1 : Form
    {
        private SystemState sysState;

        public Form1()
        {
            InitializeComponent();
            #if DEBUG
                MinimizeBox = false;
            #else       
                MinimizeBox = true;
            #endif

            sysState = new SystemState(
                  SystemProperty.OwnerEmail, true);

             sysState.Changed += new ChangeEventHandler(sysState_Changed);     
        }

        private void sysState_Changed(object sender, ChangeEventArgs args)
        {
            lblOwnerEmail.Text = SystemState.OwnerEmail;
        }

        private void butGetEmail_Click(object sender, EventArgs e)
        {
            // email  
            lblOwnerEmail.Text = SystemState.OwnerEmail;
        }

        private void butGetInfo_Click(object sender, EventArgs e)
        {
            lstInfo.Items.Add(" : " + SystemState.PhoneOperatorName);
            lstInfo.Items.Add(" : " + SystemState.PhoneRadioPresent);
            lstInfo.Items.Add(" : " + SystemState.CameraPresent);
            lstInfo.Items.Add("  " + SystemState.DisplayRotation);

        }

        private void butBattery_Click(object sender, EventArgs e)
        {
            //   
            BatteryLevel batteryLevel = SystemState.PowerBatteryStrength;
            BatteryState batteryState = SystemState.PowerBatteryState;

            string strBatteryLevel = " ";
            switch (batteryLevel)
            {
                case BatteryLevel.VeryLow:
                    strBatteryLevel = " :   (0-20%)";
                    break;
                case BatteryLevel.Low:
                    strBatteryLevel = " :  (21-40%)";
                    break;
                case BatteryLevel.Medium:
                    strBatteryLevel = " :  (41-60%)";
                    break;
                case BatteryLevel.High:
                    strBatteryLevel = " :  (61-80)";
                    break;
                case BatteryLevel.VeryHigh:
                    strBatteryLevel = " :   (81-100%)";
                    break;
            }

            //  
            string strBatteryState = " : ";
            if ((batteryState & BatteryState.Normal) == BatteryState.Normal)
                strBatteryState += " ";
            if ((batteryState & BatteryState.NotPresent) == BatteryState.NotPresent)
                strBatteryState += "  ";
            if ((batteryState & BatteryState.Charging) == BatteryState.Charging)
                strBatteryState += " ";
            if ((batteryState & BatteryState.Low) == BatteryState.Low)
                strBatteryState += "  ";
            if ((batteryState & BatteryState.Critical) == BatteryState.Critical)
                strBatteryState += "";

            MessageBox.Show(strBatteryLevel + "\n" + strBatteryState);
        }
    }
}