using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Bouncer
{
    public partial class Form1 : Form
    {
        // <summary>
        /// ,  
        /// </summary>
        private Image cheeseImage = null;

        /// <summary>
        /// ,   
        /// </summary>
        private Image breadImage = null;

        /// <summary>
        /// ,  
        /// </summary>
        private Image tomatoImage = null;

        /// <summary>
        /// ,  
        /// </summary>
        private Image bonusHamImage = null;

        /// <summary>
        /// ,   .
        /// </summary>
        private Image backgroundImage = null;


        /// <summary>
        ///   X   
        /// </summary>
        // private int cx = 0;   //  

        /// <summary>
        ///  Y   
        /// </summary>
        // private int cy = 0;   //  

        /// <summary>
        ///     
        /// </summary>
        private int xSpeed = 1;

        /// <summary>
        ///     
        /// </summary>
        private int ySpeed = 1;

        /// <summary>
        ///     X
        /// </summary>
        private bool goingRight = true;

        /// <summary>
        ///     Y
        /// </summary>
        private bool goingDown = true;

        /// <summary>
        ///   X   
        /// </summary>
        // private int bx = 0;  //  

        /// <summary>
        ///  Y   
        /// </summary>
        // private int by = 0;  //  

        /// <summary>
        ///      
        /// </summary>
        private Rectangle cheeseRectangle;

        /// <summary>
        ///       
        /// </summary>
        private Rectangle breadRectangle;

        /// <summary>
        ///      
        /// </summary>
        private Rectangle bonusHamRectangle;

        /// <summary>
        ///     
        /// </summary>
        struct tomato
        {
            public Rectangle rectangle;
            public bool visible;
        }

        /// <summary>
        ///   . 
        ///     
        /// </summary>
        private int tomatoSpacing = 4;

        /// <summary>
        /// ,    
        ///      
        ///     
        /// </summary>
        private int tomatoDrawHeight = 20;

        /// <summary>
        ///  ,    
        /// </summary>
        private int tomatoLevelStartHeight = 20;

        /// <summary>
        ///    .
        ///     
        ///  initialiseTomatoes.
        /// </summary>
        private int noOfTomatoes;

        /// <summary>
        ///     
        /// </summary>
        private tomato[] tomatoes;

        /// <summary>
        ///    
        /// </summary>
        private Font messageFont = null;

        /// <summary>
        /// ,      
        /// </summary>
        private Rectangle messageRectangle;

        /// <summary>
        ///    .
        /// </summary>
        private int scoreHeight = 15;

        /// <summary>
        /// ,   
        /// </summary>
        private SolidBrush messageBrush;

        /// <summary>
        ///    
        /// </summary>
        private string messageString = "     ";

        /// <summary>
        ///   
        /// </summary>
        private int scoreValue = 0;

        /// <summary>
        /// ,      
        /// </summary>
        private Sound batHitSound;

        /// <summary>
        /// ,     
        /// </summary>
        private Sound tomatoHitSound;

        /// <summary>
        /// ,     
        /// </summary>
        private Sound bonusHamSound;


        /// <summary>
        /// True,     .
        /// </summary>
        private bool gameLive = false;

        /// <summary>
        ///   .
        /// </summary>
        private int livesLeft;

        /// <summary>
        ///  ,   .
        /// </summary>
        private int startLives = 3;

        /// <summary>
        ///  ,   
        /// </summary>
        private int highScoreValue = 100;

        /// <summary>
        ///     
        /// </summary>
        private int maxSpeed = 5;

        /// <summary>
        ///  .      
        /// </summary>
        private bool testingGame = true;

        /// <summary>
        ///        .
        /// </summary>
        private HighScore highScore;

        /// <summary>
        ///  ,   .
        /// </summary>
        private string highScorePlayer = "Rob";

        /// <summary>
        /// ,    .
        ///       .
        /// </summary>
        private string applicationDirectory;

        /// <summary>
        ///      .
        /// </summary>
        private string highScoreFile = "highscore.bin";

        /// <summary>
        ///    ,    
        /// </summary>
        private System.Drawing.Imaging.ImageAttributes transparentWhite;



        public Form1()
        {
            InitializeComponent();

            //    
            System.Reflection.Assembly execAssem =
                System.Reflection.Assembly.GetExecutingAssembly();

            //       
            string appFilePath =
                execAssem.GetModules()[0].FullyQualifiedName;
            //          
            applicationDirectory =
                System.IO.Path.GetDirectoryName(appFilePath);
            //       
            if (!applicationDirectory.EndsWith(@"\"))
            {
                applicationDirectory += @"\";
            }


            //      
            cheeseImage = new System.Drawing.Bitmap(
                execAssem.GetManifestResourceStream(@"Bouncer.cheese.gif")
            );

            //    
            breadImage = new System.Drawing.Bitmap(
                execAssem.GetManifestResourceStream(@"Bouncer.bread.gif")
            );
           
            //     
            cheeseRectangle = new Rectangle(0, 0, cheeseImage.Width, cheeseImage.Height);
            
            //*** 
            //breadRectangle = new Rectangle(0, 0,  breadImage.Width, breadImage.Height);
            //****************************************************************************
            //         
            breadRectangle = new Rectangle(
                    (this.ClientSize.Width - breadImage.Width) / 2,
                    this.ClientSize.Height - breadImage.Height,
                    breadImage.Width,
                    breadImage.Height);

            //   
            tomatoImage = new System.Drawing.Bitmap(
                execAssem.GetManifestResourceStream(@"Bouncer.tomato.gif")
                );

            //   
            bonusHamImage = new System.Drawing.Bitmap(
                execAssem.GetManifestResourceStream(@"Bouncer.ham.gif")
                );

            //    
            backgroundImage = new System.Drawing.Bitmap(
                execAssem.GetManifestResourceStream(@"Bouncer.tablecloth.gif")
                ); 

            //     
            initialiseTomatoes();

            //      
            placeTomatoes();

            //      
            messageFont = new Font(FontFamily.GenericSansSerif,
            10, FontStyle.Regular);

            //     
            messageRectangle = new Rectangle(0, 0, this.ClientSize.Width, scoreHeight);

            //   
            messageBrush = new SolidBrush(Color.Red);

            //       
            batHitSound =
                    new Sound(execAssem.GetManifestResourceStream(@"Bouncer.click.wav"));

            //      
            tomatoHitSound =
                new Sound(execAssem.GetManifestResourceStream(@"Bouncer.burp.wav"));

            //   
			bonusHamImage = new System.Drawing.Bitmap(
				execAssem.GetManifestResourceStream(@"Bouncer.ham.gif")
				);

			//    
			bonusHamRectangle = new Rectangle( 0, 0,
				bonusHamImage.Width,bonusHamImage.Height );

            //      
            bonusHamSound =
                new Sound(execAssem.GetManifestResourceStream(@"Bouncer.pig.wav"));

            //    
            randomNumbers = new Random();

            //     
            highScore = new HighScore(this);

            //    .
            transparentWhite = new System.Drawing.Imaging.ImageAttributes();
            transparentWhite.SetColorKey(Color.White, Color.White);



            //  
            timer1.Enabled = true;

        }


        private void updatePositions()
        {
            //   

            if (goingRight)
            {
                //  
                // cx+=xSpeed;

                cheeseRectangle.X += xSpeed;
            }
            else
            {
                //cx-=xSpeed;                // 
                cheeseRectangle.X -= xSpeed;
            }
            //*** ***
            //if ((cx + cheeseImage.Width) >= this.Width) //  
            //{
            //    goingRight = false;
            //}

            //if (cx <= 0)
            //{
            //    goingRight = true;
            //}

            //if (goingDown)
            //{
            //    cy+=ySpeed;
            //}
            //else
            //{
            //    cy-=ySpeed;
            //}

            //if ((cy + cheeseImage.Height) >= this.Height)
            //{
            //    goingDown = false;
            //}

            //if (cy <= 0)
            //{
            //    goingDown = true;
            //}
            //***********************

            if ((cheeseRectangle.X + cheeseImage.Width) >= this.Width)
            {
                goingRight = false;
            }

            if (cheeseRectangle.X <= 0)
            {
                goingRight = true;
            }
          
            if (goingDown)
            {
                cheeseRectangle.Y += ySpeed;
            }
            else
            {
                cheeseRectangle.Y -= ySpeed;
            }
                       
            
            if ((cheeseRectangle.Y + cheeseImage.Height) >= this.Height)
            {
                //     
                loseLife();
                goingDown = false;
            }

            if (cheeseRectangle.Y <= 0)
            {
                goingDown = true;
            }

            if (!gameLive)
            {
                return;
            }

            //  

            if (keyArgs != null)
            {
                switch (keyArgs.KeyCode)
                {
                        //*** ***
                        //case Keys.Up:
                        //    by -= ySpeed;
                        //    break;
                        //case Keys.Down:
                        //    by += ySpeed;
                        //    break;
                        //case Keys.Left:
                        //    bx -= xSpeed;
                        //    break;
                        //case Keys.Right:
                        //    bx += xSpeed;
                        //    break;
                        //****************
                   
                        case Keys.Up:
                            breadRectangle.Y -= ySpeed;
                            break;
                        case Keys.Down:
                            breadRectangle.Y += ySpeed;
                            break;
                        case Keys.Left:
                            breadRectangle.X -= xSpeed;
                            break;
                        case Keys.Right:
                            breadRectangle.X += xSpeed;
                            break;
                }

            }

            //if (testingGame)
            //{
            //    breadRectangle.X = cheeseRectangle.X;
            //    breadRectangle.Y = ClientSize.Height - breadRectangle.Height;
            //}


            //   
            //if (cheeseRectangle.IntersectsWith(breadRectangle))
            //{
            //    goingDown = !goingDown;
            //}

            if (goingDown)
            {
                //    
                if (cheeseRectangle.IntersectsWith(breadRectangle))
                {
                    // 
                    //  
                    batHitSound.Play();

                    bool rightIn = breadRectangle.Contains(
                       cheeseRectangle.Right,
                       cheeseRectangle.Bottom);
                    bool leftIn = breadRectangle.Contains(
                       cheeseRectangle.Left,
                       cheeseRectangle.Bottom);

                    //  
                    if (rightIn & leftIn)
                    {
                        //  
                        goingDown = false;
                    }
                    else
                    {
                        //  
                        goingDown = false;
                        //     
                        if (rightIn)
                        {
                            goingRight = false;
                        }
                        if (leftIn)
                        {
                            goingRight = true;
                        }
                    }
                }

                //      
                for (int i = 0; i < tomatoes.Length; i++)
                {
                    if (!tomatoes[i].visible)
                    {
                        continue;
                    }
                    if (cheeseRectangle.IntersectsWith(tomatoes[i].rectangle))
                    {
                        //      
                        tomatoHitSound.Play();

                        //  
                        tomatoes[i].visible = false;
                        //  
                        goingDown = true;

                        //  
                        scoreValue = scoreValue + 10;
                        messageString = ": " + scoreValue;

                        //  
                        startHam();

                        //     
                        break;
                    }
                }

              }


        }

        private void changeSpeed(int change)
        {
            xSpeed += change;
            ySpeed += change;
        }

        /// <summary>
        ///       
        /// </summary>
        private void initialiseTomatoes()
        {
            noOfTomatoes = (this.ClientSize.Width - tomatoSpacing) /
               (tomatoImage.Width + tomatoSpacing);

            //  ,   
            tomatoes = new tomato[noOfTomatoes];

            //  x  
            int tomatoX = tomatoSpacing / 2;

            for (int i = 0; i < tomatoes.Length; i++)
            {
                tomatoes[i].rectangle =
                   new Rectangle(tomatoX, tomatoDrawHeight,
                   tomatoImage.Width, tomatoImage.Height);
                tomatoX = tomatoX + tomatoImage.Width + tomatoSpacing;
            }
        }

        /// <summary>
        ///     .
        /// </summary>
        private void placeTomatoes()
        {
            for (int i = 0; i < tomatoes.Length; i++)
            {
                tomatoes[i].rectangle.Y = tomatoDrawHeight;
                tomatoes[i].visible = true;
            }
        }

        private void startGame()
        {
            //   ,   
            livesLeft = startLives;
            scoreValue = 0;
            messageString = ": 0 : " + livesLeft;

            //    
            tomatoDrawHeight = tomatoLevelStartHeight;
            placeTomatoes();

            //     
            breadRectangle.X = (this.ClientSize.Width - breadRectangle.Width) / 2;
            breadRectangle.Y = this.ClientSize.Height / 2;

            //       
            cheeseRectangle.X = (this.ClientSize.Width - cheeseRectangle.Width) / 2;
            cheeseRectangle.Y = breadRectangle.Y - cheeseRectangle.Height;

            //   
            xSpeed = 1;
            ySpeed = 1;

            //  ,   
            gameLive = true;
        }

        private void loseLife()
        {
            if (!gameLive)
            {
                return;
            }
            //     
            livesLeft--;
            if (livesLeft > 0)
            {
                //    
                messageString = ": " + scoreValue + "  : " + livesLeft;
            }
            else
            {
                //  
                gameLive = false;
                //    
                if (scoreValue > highScoreValue)
                {
                    highScoreValue = scoreValue;
                    timer1.Enabled = false;
                    //     
                    highScore.ShowDialog();
                    timer1.Enabled = true;
                    highScorePlayer = highScore.PlayerName;
                }
                //    
                messageString = " : " + highScoreValue;
            }
        }

        private void newLevel()
        {
            if (!gameLive)
            {
                return;
            }
            //    
            tomatoDrawHeight += tomatoSpacing;

            if (tomatoDrawHeight >
               (ClientSize.Height - (breadRectangle.Height + tomatoImage.Height)))
            {
                //        
                tomatoDrawHeight = tomatoLevelStartHeight;
            }
            placeTomatoes();
            //  
            if (xSpeed < maxSpeed)
            {
                xSpeed++;
                ySpeed++;
            }
        }

        /// <summary>
        /// True,    
        /// </summary>
        private bool hamPresent = false;

        /// <summary>
        ///   0  10.   ,
        ///      
        /// </summary>
        private int hamLikelihood = 5;

        /// <summary>
        ///     .
        ///      .
        /// </summary>
        private int hamTimerCount;

        /// <summary>
        ///  .
        /// </summary>
        private Random randomNumbers;

        /// <summary>
        ///    
        /// </summary>
        private void startHam()
        {
            //  ,      
            if (hamPresent)
            {
                return;
            }
            // ,      
            if (randomNumbers.Next(10) > hamLikelihood)
            {
                //     
                return;
            }
            //       
            bonusHamRectangle.X =
               randomNumbers.Next(ClientSize.Width - bonusHamRectangle.Width);
            bonusHamRectangle.Y =
               randomNumbers.Next(ClientSize.Height - bonusHamRectangle.Height);
            //       
            // (   50 )
            hamTimerCount = 50 + randomNumbers.Next(100);
            //   
            hamPresent = true;
        }

        /// <summary>
        ///   
        /// </summary>
        private void hamTick()
        {
            //   ,   
            if (!hamPresent)
            {
                return;
            }
            if (breadRectangle.IntersectsWith(bonusHamRectangle))
            {
                //     
                //  100 
                scoreValue = scoreValue + 100;
                messageString = ": " + scoreValue + "  : " + livesLeft;
                //   
                bonusHamSound.Play();
                //    
                hamPresent = false;
            }
            else
            {
                //   
                hamTimerCount--;
                if (hamTimerCount == 0)
                {
                    //     
                    hamPresent = false;
                }
            }
        }

        /// <summary>
        ///     .
        /// </summary>
        public void SaveHighScore()
        {
            System.IO.TextWriter writer = null;
            try
            {
                writer = new System.IO.StreamWriter(
                    applicationDirectory + highScoreFile);
                writer.WriteLine(highScorePlayer);
                writer.WriteLine(highScoreValue);
            }
            catch { }
            finally
            {
                if (writer != null)
                {
                    writer.Close();
                }
            }
        }

        /// <summary>
        ///     .
        /// </summary>
        public void LoadHighScore()
        {
            System.IO.TextReader reader = null;
            try
            {
                reader = new System.IO.StreamReader(
                    applicationDirectory + highScoreFile);
                highScorePlayer = reader.ReadLine();
                string highScoreString = reader.ReadLine();
                highScoreValue = int.Parse(highScoreString);
            }
            catch { }
            finally
            {
                if (reader != null)
                {
                    reader.Close();
                }
            }
        }


        protected override void OnPaintBackground(PaintEventArgs pevent)
        {
            //      
        } 

        /// <summary>
        /// -
        /// </summary>
        private Bitmap backBuffer = null;

        private void Form1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
        {
            //   
            if (backBuffer == null)
            {
                backBuffer = new Bitmap(this.ClientSize.Width, this.ClientSize.Height);
            }

            using (Graphics g = Graphics.FromImage(backBuffer))
            {
                //*** ****
                g.Clear(Color.White);
                //***********************
                g.DrawImage(backgroundImage, 0, 0);

                bool gotTomato = false;
                //   
                for (int i = 0; i < tomatoes.Length; i++)
                {
                    if (tomatoes[i].visible)
                    {
                        gotTomato = true;

                        //*** *******************************
                        g.DrawImage(tomatoImage,
                           tomatoes[i].rectangle.X, tomatoes[i].rectangle.Y);
                        //********************************************************

                        g.DrawImage(
                                                tomatoImage,        // Image
                                                tomatoes[i].rectangle,    // Dest. rect.
                                                0,					// srcX
                                                0,					// srcY
                                                tomatoImage.Width,  // srcWidth
                                                tomatoImage.Height, // srcHeight
                                                GraphicsUnit.Pixel, // srcUnit
                                                transparentWhite);  // ImageAttributes
                    }
                }

                if (!gotTomato)
                {
                    newLevel();
                }

                // *** ***********
                //  
                //g.DrawImage(cheeseImage, cx, cy);
                //  
                //g.DrawImage(breadImage, bx, by);
                //***********************************

                //     
                if (hamPresent)
                {
                    //*** ***
                    //g.DrawImage(bonusHamImage, bonusHamRectangle.X, bonusHamRectangle.Y);
                    //************************************************************

                    g.DrawImage(
						bonusHamImage,        // Image
						bonusHamRectangle,    // Dest. rect.
						0,					// srcX
						0,					// srcY
						bonusHamRectangle.Width,  // srcWidth
						bonusHamRectangle.Height, // srcHeight
						GraphicsUnit.Pixel, // srcUnit
						transparentWhite);  // ImageAttributes
				}

                //     
                //*** ***
                //g.DrawImage(breadImage, breadRectangle.X, breadRectangle.Y);
                //************************************************************

                g.DrawImage(
                    breadImage,        // Image
                    breadRectangle,    // Dest. rect.
                    0,					// srcX
                    0,					// srcY
                    breadRectangle.Width,  // srcWidth
                    breadRectangle.Height, // srcHeight
                    GraphicsUnit.Pixel, // srcUnit
                    transparentWhite);  // ImageAttributes

                
                //     
                //*** ***
                //g.DrawImage(cheeseImage, cheeseRectangle.X, cheeseRectangle.Y);
                //************************************************************

                g.DrawImage(
                    cheeseImage,        // Image
                    cheeseRectangle,    // Dest. rect.
                    0,                  // srcX
                    0,                  // srcY
                    cheeseRectangle.Width,  // srcWidth
                    cheeseRectangle.Height, // srcHeight
                    GraphicsUnit.Pixel,     // srcUnit
                    transparentWhite);      // ImageAttributes




                g.DrawString(messageString, messageFont, messageBrush, messageRectangle);

            }
            e.Graphics.DrawImage(backBuffer, 0, 0);

            

        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            updatePositions();
            hamTick();
            Invalidate();
        }

        /// <summary>
        ///  keyArgs   
        /// </summary>
        private System.Windows.Forms.KeyEventArgs keyArgs = null;

        private void Form1_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
        {
            keyArgs = e;
        }

        private void Form1_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
        {
            keyArgs = null;
        }

        private void menuItem1_Click(object sender, EventArgs e)
        {
            //changeSpeed(1);
            startGame();
        }

        private void menuItem2_Click(object sender, EventArgs e)
        {
            //changeSpeed(-1);
            Application.Exit();
            

        }

    }
}