using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Bouncer
{
    public partial class Form1 : Form
    {
        #region  
        // <summary>
        /// ,  
        /// </summary>
        //private Image cheeseImage = null;

        /// <summary>
        /// ,   
        /// </summary>
        //private Image breadImage = null;

        /// <summary>
        /// ,  
        /// </summary>
        //private Image tomatoImage = null;

        /// <summary>
        /// ,  
        /// </summary>
        //private Image bonusHamImage = null;

        /// <summary>
        /// ,   .
        /// </summary>
        //private Image backgroundImage = null;


        /// <summary>
        ///   X   
        /// </summary>
        // private int cx = 0;   //  

        /// <summary>
        ///  Y   
        /// </summary>
        // private int cy = 0;   //  

        /// <summary>
        ///     
        /// </summary>
        //private tomato[] tomatoes;

        /// <summary>
        /// True,    
        /// </summary>
        //private bool hamPresent = false;
#endregion


        //    
        /// <summary>
        ///  .    .   
        /// </summary>
        ForeSprite Cheese;

        /// <summary>
        ///  .    .   
        /// </summary>
        ForeSprite Bread;

        /// <summary>
        ///  -  .        .
        /// </summary>
        ForeSprite Ham;

        /// <summary>
        /// .   .     
        ///  
        /// </summary>
        BackSprite Tomato;

        /// <summary>
        ///  .    ,   
        ///     .
        /// </summary>
        Background TableCloth;

        /// <summary>
        ///  .    .
        /// </summary>
        PlayField Field;

        /// <summary>
        ///   . 
        ///     
        /// </summary>
        private int tomatoSpacing = 4;

        /// <summary>
        ///  ,    
        /// </summary>
        private int tomatoLevelStartHeight = 20;

        /// <summary>
        /// ,    
        ///      
        ///     
        /// </summary>
        private int tomatoDrawHeight = 20;

        /// <summary>
        ///    .
        ///     
        ///  initialiseTomatoes.
        /// </summary>
        private int noOfTomatoes;

        /// <summary>
        ///     
        /// </summary>
        private BackSprite[] tomatoes;

        /// <summary>
        ///   
        /// </summary>
        private int scoreValue = 0;

        /// <summary>
        /// ,      
        /// </summary>
        private Sound batHitSound;

        /// <summary>
        /// ,     
        /// </summary>
        private Sound tomatoHitSound;

        /// <summary>
        /// ,     
        /// </summary>
        private Sound bonusHamSound;

        /// <summary>
        /// True,     .
        /// </summary>
        private bool gameLive = false;

        /// <summary>
        ///   .
        /// </summary>
        private int livesLeft;

        /// <summary>
        ///  ,   .
        /// </summary>
        private int startLives = 3;

        /// <summary>
        ///  ,   
        /// </summary>
        private int highScoreValue = 0;

        /// <summary>
        ///  ,   .
        /// </summary>
        private string highScorePlayer = "Rob";

        /// <summary>
        ///     
        /// </summary>
        private int maxSpeed = 5;

        /// <summary>
        ///      .
        /// </summary>
        private string highScoreFile = "highscore.bin";

        /// <summary>
        /// ,    .
        ///       .
        /// </summary>
        private string applicationDirectory;

        /// <summary>
        ///        .
        /// </summary>
        private HighScore highScore;

        /// <summary>
        ///    ,    
        /// </summary>
        private System.Drawing.Imaging.ImageAttributes transparentWhite;

        /// <summary>
        ///     X
        /// </summary>
        private bool goingRight = true;

        /// <summary>
        ///     Y
        /// </summary>
        private bool goingDown = true;

        /// <summary>
        ///     
        /// </summary>
        private int xSpeed = 1;

        /// <summary>
        ///     
        /// </summary>
        private int ySpeed = 1;

        /// <summary>
        ///  .      
        /// </summary>
        private bool testingGame = false;

        public Form1()
        {
            InitializeComponent();

            //    
            System.Reflection.Assembly execAssem =
                System.Reflection.Assembly.GetExecutingAssembly();

            //    
            Cheese = new ForeSprite( execAssem, "cheese.gif" ) ;
			Bread = new ForeSprite( execAssem, "bread.gif" ) ;
			Tomato = new BackSprite( execAssem, "tomato.gif" ) ;
			Ham = new ForeSprite( execAssem, "ham.gif" ) ;
            TableCloth = new Background(execAssem, "tablecloth.gif");

            Field = new PlayField(TableCloth, ClientSize.Width, ClientSize.Height);

            Field.AddForegroundSprite(Bread);
            Field.AddForegroundSprite(Cheese);

            Ham.Visible = false;
            Bread.Visible = false;
            Field.AddForegroundSprite(Ham);

            //     
            initialiseTomatoes();

            //       
            batHitSound =
                    new Sound(execAssem.GetManifestResourceStream(@"Bouncer.click.wav"));

            //      
            tomatoHitSound =
                new Sound(execAssem.GetManifestResourceStream(@"Bouncer.burp.wav"));

            //      
            bonusHamSound =
                new Sound(execAssem.GetManifestResourceStream(@"Bouncer.pig.wav"));

            //    
            randomNumbers = new Random();

            //       
            string appFilePath =
                execAssem.GetModules()[0].FullyQualifiedName;
            //          
            applicationDirectory =
                System.IO.Path.GetDirectoryName(appFilePath);
            //       
            if (!applicationDirectory.EndsWith(@"\"))
            {
                applicationDirectory += @"\";
            }

            LoadHighScore();

            //     
            Field.Message = highScorePlayer + " : " + highScoreValue;

            //     
            highScore = new HighScore(this);

            //    .
            transparentWhite = new System.Drawing.Imaging.ImageAttributes();
            transparentWhite.SetColorKey(Color.White, Color.White);

            //  
            timer1.Enabled = true;
          }


        private void updatePositions()
        {
            //   

            if (goingRight)
            {
                Cheese.X += xSpeed;
            }
            else
            {
                Cheese.X -= xSpeed;
            }

            if ((Cheese.X + Cheese.Width) >= this.Width)
            {
                goingRight = false;
            }

            if (Cheese.X <= 0)
            {
                goingRight = true;
            }
          
            if (goingDown)
            {
                Cheese.Y += ySpeed;
            }
            else
            {
                Cheese.Y -= ySpeed;
            }


            if ((Cheese.Y + Cheese.Height) >= this.Height)
            {
                //     
                loseLife();
                goingDown = false;
            }

            if (Cheese.Y <= Field.Messageheight)
            {
                goingDown = true;
            }

            if (!gameLive)
            {
                return;
            }

            //   

            if (keyArgs != null)
            {
                switch (keyArgs.KeyCode)
                {
                                           
                        case Keys.Up:
                            Bread.Y -= ySpeed;
                            break;
                        case Keys.Down:
                            Bread.Y += ySpeed;
                            break;
                        case Keys.Left:
                            Bread.X -= xSpeed;
                            break;
                        case Keys.Right:
                            Bread.X += xSpeed;
                            break;
                }

            }

            if (testingGame)
            {
                Bread.X = Cheese.X;
                Bread.Y = ClientSize.Height - Bread.Height;
            }

            //   
            bool noTomatoes = true;

            if (goingDown)
            {
                //      
                if (Cheese.IntersectsWith(Bread))
                {
                    // 
                    //  
                    batHitSound.Play();

                    bool rightIn = Bread.Contains(Cheese.Right, Cheese.Bottom);
                    bool leftIn = Bread.Contains(Cheese.Left, Cheese.Bottom);

                    //  
                    if (rightIn & leftIn)
                    {
                        //  
                        goingDown = false;
                    }
                    else
                    {
                        //  
                        goingDown = false;
                        //     
                        if (rightIn)
                        {
                            goingRight = false;
                        }
                        if (leftIn)
                        {
                            goingRight = true;
                        }
                    }
                }
            }

                //      
                foreach (BackSprite tomato in tomatoes)
                {
                    if (!(tomato.DrawState == BackSprite.BackSpriteState.visible))
                    {
                        continue;
                    }

                    noTomatoes = false;

                    if (Cheese.SpriteRect.IntersectsWith(tomato.SpriteRect)) 
                    {
                        //      
                        tomatoHitSound.Play();

                        //  
                        tomato.DrawState = BackSprite.BackSpriteState.disappearing;
                        
                        //  
                        scoreValue = scoreValue + 10;
                        Field.Message = ": " + scoreValue + "  : " + livesLeft;

                        //    
                        goingDown = !goingDown;

                        //  
                        startHam();

                        //      
                        break;
                    }
                }
                if (noTomatoes)
                {
                    newLevel();
                }
                hamTick();
  
        }

        /// <summary>
        ///       x  y
        /// </summary>
        /// <param name="change"> .   .</param>
        private void changeSpeed(int change)
        {
            xSpeed += change;
            ySpeed += change;
        }

        /// <summary>
        ///       
        /// </summary>
        private void initialiseTomatoes()
        {
            noOfTomatoes =
                (Field.WindowWidth - tomatoSpacing) /
                (Tomato.Width + tomatoSpacing);

            //  ,   
            tomatoes = new BackSprite[noOfTomatoes];

            //  x  
            int tomatoX = tomatoSpacing / 2;

            for (int i = 0; i < tomatoes.Length; i++)
            {
                tomatoes[i] = new BackSprite(Tomato, tomatoX, tomatoDrawHeight);
                Field.AddBackgroundSprite(tomatoes[i]);
                tomatoX = tomatoX + Tomato.Width + tomatoSpacing;
            }            
        }

        /// <summary>
        ///     .
        /// </summary>
        private void placeTomatoes()
        {
            foreach (BackSprite s in tomatoes)
            {
                s.SpriteRect.Y = tomatoDrawHeight;
                s.DrawState = BackSprite.BackSpriteState.appearing;
            }
        }

        private void startGame()
        {
            //  
            Field.ClearBackground();

            //      
            Cheese.SpriteRect.X = ClientSize.Width / 2;
            Cheese.SpriteRect.Y = ClientSize.Height / 2;

            //  
            Ham.Visible = false;

            //       ()
            Bread.SpriteRect.X = (ClientSize.Width - Bread.Width) / 2;
            Bread.SpriteRect.Y = ClientSize.Height - Bread.Height - 20;
            Bread.Visible = true;

            //      
            livesLeft = startLives;
            scoreValue = 0;

            //      
            tomatoDrawHeight = tomatoLevelStartHeight;
            placeTomatoes();

            //   
            xSpeed = 1;
            ySpeed = 1;

            // update the message
            Field.Message = "Score : " + scoreValue + "  Lives: " + livesLeft;

            //  ,   
            gameLive = true;
        }

        private void loseLife()
        {
            if (!gameLive)
            {
                return;
            }
            //     
            livesLeft--;
            if (livesLeft > 0)
            {
                //    
                Field.Message = ": " + scoreValue + "  : " + livesLeft;
            }
            else
            {
                //  
                gameLive = false;
                //    
                if (scoreValue > highScoreValue)
                {
                    highScoreValue = scoreValue;
                    timer1.Enabled = false;
                    //     
                    highScore.ShowDialog();
                    timer1.Enabled = true;
                    highScorePlayer = highScore.PlayerName;
                }
                //    
                Field.Message = highScorePlayer + " : " + highScoreValue;
            }
        }

        private void newLevel()
        {
            if (!gameLive)
            {
                return;
            }
            //    
            tomatoDrawHeight += tomatoSpacing;

            if (tomatoDrawHeight > (ClientSize.Height - (Bread.Height + Tomato.Height))) 
            {
                //        
                tomatoDrawHeight = tomatoLevelStartHeight;
            }
            placeTomatoes();

            //  
            if (xSpeed < maxSpeed)
            {
                xSpeed++;
                ySpeed++;
            }
        }

        /// <summary>
        ///   0  10.   ,
        ///      
        /// </summary>
        private int hamLikelihood = 5;

        /// <summary>
        ///     .
        ///      .
        /// </summary>
        private int hamTimerCount;

        /// <summary>
        ///  .
        /// </summary>
        private Random randomNumbers;

        /// <summary>
        ///    
        /// </summary>
        private void startHam()
        {
            //  ,      
            if (Ham.Visible)
            {
                return;
            }
            // ,      
            if (randomNumbers.Next(10) > hamLikelihood)
            {
                //     
                return;
            }
            //       
            Ham.X = randomNumbers.Next(ClientSize.Width - Ham.Width);
            Ham.Y = randomNumbers.Next(ClientSize.Height - Ham.Height);
            //   
            Ham.Visible = true;

            //       
            // (   50 )
            hamTimerCount = 50 + randomNumbers.Next(100);

        }

        /// <summary>
        ///   
        /// </summary>
        private void hamTick()
        {
            //   ,   
            if (!Ham.Visible)
            {
                return;
            }
            if (Bread.IntersectsWith(Ham))
            {
                //     
                //  100 
                scoreValue = scoreValue + 100;
                Field.Message = ": " + scoreValue + "  : " + livesLeft;
                //   
                bonusHamSound.Play();
                //    
                Ham.Visible = false;
            }
            else
            {
                //   
                hamTimerCount--;
                if (hamTimerCount == 0)
                {
                    //     
                    Ham.Visible = false;
                }
            }
        }

        /// <summary>
        ///     .
        /// </summary>
        public void SaveHighScore()
        {
            System.IO.TextWriter writer = null;
            try
            {
                writer = new System.IO.StreamWriter(
                    applicationDirectory + highScoreFile);
                writer.WriteLine(highScorePlayer);
                writer.WriteLine(highScoreValue);
            }
            catch { }
            finally
            {
                if (writer != null)
                {
                    writer.Close();
                }
            }
        }

        /// <summary>
        ///     .
        /// </summary>
        public void LoadHighScore()
        {
            System.IO.TextReader reader = null;
            try
            {
                reader = new System.IO.StreamReader(
                    applicationDirectory + highScoreFile);
                highScorePlayer = reader.ReadLine();
                string highScoreString = reader.ReadLine();
                highScoreValue = int.Parse(highScoreString);
            }
            catch { }
            finally
            {
                if (reader != null)
                {
                    reader.Close();
                }
            }
        }


        protected override void OnPaintBackground(PaintEventArgs pevent)
        {
            //      
        } 

        /// <summary>
        /// -
        /// </summary>
        //private Bitmap backBuffer = null;

        private void Form1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
        {
            Field.doPaint(sender, e);
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            Field.ClearForeground();
            updatePositions();
            Field.DrawForeground();
            Invalidate();
        }

        /// <summary>
        ///  keyArgs   
        /// </summary>
        private System.Windows.Forms.KeyEventArgs keyArgs = null;

        private void Form1_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
        {
            keyArgs = e;
        }

        private void Form1_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
        {
            keyArgs = null;
        }

        private void menuItem1_Click(object sender, EventArgs e)
        {
            startGame();
        }

        private void menuItem2_Click(object sender, EventArgs e)
        {
            SaveHighScore();
            Application.Exit();
        }

    }
}