using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;


namespace BluetoothStatus_CS
{
    public partial class Form1 : Form
    {
        public enum RadioMode
        {
            Off = 0,
            Connectable = 1,
            Discoverable = 2
        }

        /// <summary>
        ///    bluetooth
        /// </summary>
        /// <param name="dwMode"></param>
        /// <returns></returns>
        [DllImport("BthUtil.dll")]
        public static extern int BthGetMode(out RadioMode dwMode);

        /// <summary>
        ///    bluetooth
        /// </summary>
        /// <param name="dwMode">   </param>
        /// <returns></returns>
        [DllImport("BthUtil.dll")]
        public static extern int BthSetMode(RadioMode dwMode);
 
        public Form1()
        {
            InitializeComponent();
        }

        private void mnuExit_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void mnuOn_Click(object sender, EventArgs e)
        {
            BthSetMode(RadioMode.Connectable);
            lblStatus.Text = RadioMode.Connectable.ToString();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            RadioMode mode;
            int ret = BthGetMode (out mode);
            lblStatus.Text = mode.ToString();
        }

        private void mnuOff_Click(object sender, EventArgs e)
        {
            BthSetMode(RadioMode.Off);
            lblStatus.Text = RadioMode.Off.ToString();
        }
    }
}