using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.IO;

namespace IrDA_CS
{
    public partial class Form1 : Form
    {
        private IrDAListener irListen;
        private IrDAClient irClient;
        private IrDAEndPoint irEndP;
        private IrDADeviceInfo[] irDevices;

        string fileSend;
        string fileReceive;
        string irServiceName;

        int buffersize;


        public Form1()
        {
            InitializeComponent();
            irClient = new IrDAClient();

            // ,     
            fileSend = ".\\My Documents\\send.txt";
            fileReceive = ".\\My Documents\\receive.txt";

            //     IrDA
            //     
            //         
            irServiceName = "IrDA";

            //       
            buffersize = 256;

            //       
            //   ,     
            butSend.Enabled = false;
            butReceive.Enabled = false;

        }

        private void butFindDevs_Click(object sender, EventArgs e)
        {
            //      
            //     
            //          
            //      
            irDevices = irClient.DiscoverDevices(2);

            //    ,   
            if (irDevices.Length == 0)
            {
                MessageBox.Show("  -  !");
                return;
            }

            //   IrDADeviceInfo
            //        
            string device;
            int ID;
            listBox1.Items.Clear();
            foreach (IrDADeviceInfo irDevice in irDevices)
            {
                ID = BitConverter.ToInt32(irDevice.DeviceID, 0);
                device = ID.ToString() + " " + irDevice.DeviceName + " "
                    + irDevice.CharacterSet + " " + irDevice.Hints;
                listBox1.Items.Add(device);
            }

            listBox1.SelectedIndex = 0;
            if (irDevices.Length > 0)
                statusBar1.Text =
                    irDevices.Length.ToString() + " ()";

            //        
            butSend.Enabled = true;
            butReceive.Enabled = true;
        }

        private void butSend_Click(object sender, EventArgs e)
        {
            //        
            Stream fileStream;
            try
            {
                fileStream = new FileStream(fileSend, FileMode.Open);
            }
            catch (Exception exFile)
            {
                MessageBox.Show("   " + exFile.ToString());
                return;
            }

            //  IrDA-    ,
            //         IrDA-
            try
            {
                irClient = new IrDAClient(irServiceName);
            }
            catch (SocketException exS)
            {
                MessageBox.Show(" : " + exS.Message +
                    " -        ?");
                return;
            }

            //  
            Stream baseStream = irClient.GetStream();

            //    
            //      
            byte[] length = BitConverter.GetBytes((int)fileStream.Length);
            baseStream.Write(length, 0, length.Length);

            //     
            byte[] buffer = new byte[buffersize];

            //    
            int fileLength = (int)fileStream.Length;
            statusBar1.Text = " " + fileLength + " ";

            //      
            while (fileLength > 0)
            {
                int numRead = fileStream.Read(buffer, 0, buffer.Length);
                baseStream.Write(buffer, 0, numRead);
                fileLength -= numRead;
            }

            fileStream.Close();
            baseStream.Close();
            irClient.Close();
            statusBar1.Text = " ";

        }

        private void butReceive_Click(object sender, EventArgs e)
        {
            //     
            Stream writeStream;
            try
            {
                writeStream = new FileStream(fileReceive,
                    FileMode.OpenOrCreate);
            }
            catch (Exception)
            {
                MessageBox.Show("   "
                    + fileReceive + "  ");
                return;
            }

            //      IrDAEndPoint
            //     
            //    
            //     IrDAListener
            try
            {
                int i = listBox1.SelectedIndex;
                irEndP = new IrDAEndPoint(irDevices[i].DeviceID,
                    irServiceName);
                irListen = new IrDAListener(irEndP);
                irListen.Start();
            }
            catch (SocketException exSoc)
            {
                MessageBox.Show("     "
                    + irServiceName + ": "
                    + exSoc.ErrorCode);
            }

            //    
            statusBar1.Text = " "
                + listBox1.SelectedItem.ToString();

            //  
            //  ,  
            IrDAClient irClient;
            try
            {
                irClient = irListen.AcceptIrDAClient();
            }
            catch (SocketException exp)
            {
                MessageBox.Show("    "
                    + exp.ErrorCode);
                return;
            }

            //     
            if (irListen.Pending() == true)
                statusBar1.Text = "  "
                    + irClient.RemoteMachineName;
            else
                statusBar1.Text = "   "
                    + irClient.RemoteMachineName;

            //    
            Stream baseStream = irClient.GetStream();

            int numToRead;

            //     
            byte[] buffer = new byte[buffersize];

            //   ,  
            //    
            numToRead = 4;
            while (numToRead > 0)
            {
                int numRead = baseStream.Read(buffer, 0, numToRead);
                numToRead -= numRead;
            }

            //     
            //      
            numToRead = BitConverter.ToInt32(buffer, 0);
            statusBar1.Text = " "
                + numToRead + " ";

            //       , 
            //      
            while (numToRead > 0)
            {
                int numRead = baseStream.Read(buffer, 0, buffer.Length);
                numToRead -= numRead;
                writeStream.Write(buffer, 0, numRead);
            }

            // ,   
            statusBar1.Text = " ";

            baseStream.Close();
            writeStream.Close();
            irListen.Stop();
            irClient.Close();
        }
    }
}