using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace Registry_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            #if DEBUG
                MinimizeBox = false;
            #else       
                MinimizeBox = true;
            #endif
        }

 

        private void button1_Click(object sender, EventArgs e)
        {
            
            
            int result =  Registry.CreateKey(Registry.HKLM, "Software\\Microsoft\\Color");
            if (result != Registry.ERROR_SUCCESS)
            {
                lblInfo.Text = "   ";             
            }


        }

        private void button2_Click(object sender, EventArgs e)
        {
            Registry.CreateValueDWORD(Registry.HKLM, "Software\\Microsoft\\Shell", "TBOpt", 3);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Registry.CreateValueBinary(Registry.HKLM, "Software\\Microsoft\\Color", "40", 0x0000FFFF);
        }

        private void butCheckKeyboard_Click(object sender, EventArgs e)
        {
            //lblInfo.Text = IsKeyboard().ToString();
            uint check = 0;
            Registry.GetDWORDValue(Registry.HKCU, "SOFTWARE\\Microsoft\\Shell", "HasKeyboard", ref check);
            lblInfo.Text = Convert.ToBoolean(check).ToString();
        }

        private static bool IsKeyboard()
        {
           
                uint dwordResult;
                UIntPtr hkey = UIntPtr.Zero;

                try
                {
                    int result = Registry.RegOpenKeyEx(Registry.HKCU, "SOFTWARE\\Microsoft\\Shell", 0, Registry.KeyAccess.None, ref hkey);
                    if (Registry.ERROR_SUCCESS != result)
                        return false;

                    byte[] bytes = null;
                    uint length = 0;
                    Registry.KeyType keyType = Registry.KeyType.None;

                    result = Registry.RegQueryValueEx(hkey, "HasKeyboard", IntPtr.Zero, ref keyType,
                        null, ref length);

                    if (Registry.ERROR_SUCCESS != result)
                        return false;

                    bytes = new byte[Marshal.SizeOf(typeof(uint))];
                    length = (uint)bytes.Length;
                    keyType = Registry.KeyType.None;

                    result = Registry.RegQueryValueEx(hkey, "HasKeyboard", IntPtr.Zero, ref keyType,
                        bytes, ref length);

                    if (Registry.ERROR_SUCCESS != result)
                        return false;

                    dwordResult = BitConverter.ToUInt32(bytes, 0);

                    return (dwordResult == 1);
                }
                finally
                {
                    if (UIntPtr.Zero != hkey)
                    {
                        Registry.RegCloseKey(hkey);
                    }
                }          
        }

        private void butOwner_Click(object sender, EventArgs e)
        {
            string strOwner = "";
            Registry.GetStringValue(Registry.HKCU, "\\ControlPanel\\Owner", "Owner", ref strOwner);
            lblInfo.Text = strOwner;
        }

    }
}
