using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using Microsoft.WindowsCE.Forms;

namespace ScreenRotate_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            #if DEBUG
                MinimizeBox = false;
            #else       
                MinimizeBox = true;
            #endif
        }

        // ,    
        private static Int32 DisplayQueryOrientation = 0x01000000;

        private static Int32 CDS_TEST = 2;

        //   
        ScreenOrientation initialOrientation = SystemSettings.ScreenOrientation;

        [DllImport("coredll.dll", SetLastError = true)]
        private extern static Int32 ChangeDisplaySettingsEx(
            String deviceName,
            ref DeviceMode deviceMode,
            IntPtr hwnd,
            Int32 flags,
            IntPtr param);

    struct DeviceMode
    {
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 32)]
        public String DeviceName;
        public Int16 SpecVersion;
        public Int16 DriverVersion;
        public Int16 Size;
        public Int16 DriverExtra;
        public Int32 Fields;
        public Int16 Orientation;
        public Int16 PaperSize;
        public Int16 PaperLength;
        public Int16 PaperWidth;
        public Int16 Scale;
        public Int16 Copies;
        public Int16 DefaultSource;
        public Int16 PrintQuality;
        public Int16 Color;
        public Int16 Duplex;
        public Int16 YResolution;
        public Int16 TTOption;
        public Int16 Collate;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 32)]
        public String FormName;
        public Int16 LogPixels;
        public Int32 BitsPerPel;
        public Int32 PelsWidth;
        public Int32 PelsHeight;
        public Int32 DisplayFlags;
        public Int32 DisplayFrequency;
        public Int32 DisplayOrientation;

    }

         private void butCheckRotate_Click(object sender, EventArgs e)
        {
            //   DeviceMode
            DeviceMode devMode = new DeviceMode();
            devMode.Size = (Int16)Marshal.SizeOf(devMode);
            devMode.Fields = DisplayQueryOrientation;

            // ,     
            Int32 result = ChangeDisplaySettingsEx(
                null,
                ref devMode,
                IntPtr.Zero,
                CDS_TEST,
                IntPtr.Zero);

            if (result == 0)
            {
                //     ,
                //     

                //   DisplayOrientation   
                //    
                if (devMode.DisplayOrientation != 0)
                {
                    MessageBox.Show("  ");
                }
          
            }
            else
            {
                MessageBox.Show("   ");
            }

         }

        private void butRot90_Click(object sender, EventArgs e)
        {
            SystemSettings.ScreenOrientation = ScreenOrientation.Angle90;
        }     

        private void butRestore_Click(object sender, EventArgs e)
        {
if (SystemSettings.ScreenOrientation != initialOrientation)
            {
                try
                {
                    SystemSettings.ScreenOrientation = initialOrientation;
                }
                catch (Exception)
                {
                    // Unable to change the orientation back 
                    // to the original configuration. 

                    MessageBox.Show("This sample was unable to set the " +
                        "orientation back to the original state.");
                }
            }
        }
    }
}