using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;

using System.IO;
using System.Reflection;
using System.Runtime.InteropServices;


namespace Bricks_CS
{
    public partial class Form1 : Form
    {
        [DllImport("coredll.dll")]
        public static extern Int32 SetForegroundWindow(IntPtr hWnd);

        [DllImport("coredll.dll", EntryPoint = "GetDesktopWindow")]
        public static extern IntPtr GetDesktopWindow();


        public Form1()
        {
            InitializeComponent();
            #if DEBUG
                MinimizeBox = false;
            #else       
                MinimizeBox = true;
            #endif

        }
      
        private void butWaitCursor_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;
        }

        private void butWaitCursorOff_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.Default;
        }


        private void butSendMail_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start
                ("mailto:alexander.klimoff@gmail.com?subject=About Book", null);
        }


        private void cboList_SelectedValueChanged(object sender, EventArgs e)
        {
            string curItem = cboList.SelectedItem.ToString();

            switch (curItem)
            {
                //     .NET Compact Framework
                case "  .NET Compact Framework":
                    txtInfo.Text = Environment.Version.ToString();
                    break;
                    
                //    
                case "  ":
                    txtInfo.Text = Environment.OSVersion.ToString();
                    break;

                //    
                case "   ":
                    txtInfo.Text = Path.GetDirectoryName(Assembly.GetExecutingAssembly().GetModules()[0].FullyQualifiedName).ToString();
                    break;

                    //      Start Up
                case "     Start Up":
                    txtInfo.Text = Environment.GetFolderPath(Environment.SpecialFolder.Startup).ToString();
                    break;

                //  
                case "  ":
                    txtInfo.Text = System.Net.Dns.GetHostName().ToString();
                    break;

                //   
                case "  ":
                    txtInfo.Text = Screen.PrimaryScreen.Bounds.Width + ":" +
                             Screen.PrimaryScreen.Bounds.Height;
                    break;

                //    
                case "    ":
                    System.Diagnostics.Process.Start("\\My Music\\myfile.mp3",null);
                    break;
               //   
                case "   ":
                    txtInfo.Text = GetStorageCardNames()[0].ToString();
                    break;

               //  
                case "  ":
                    SetForegroundWindow(GetDesktopWindow());
                    break;
                    
            }
        }

        
        //      
        public static string[] GetStorageCardNames()
        {
            ArrayList scards = new ArrayList();
            DirectoryInfo rootDir = new DirectoryInfo(@"\");

            foreach (DirectoryInfo di in rootDir.GetDirectories())
            {
                //     Directory  Temporary
                FileAttributes attrStorageCard = FileAttributes.Directory & FileAttributes.Temporary;

                if ((di.Attributes & attrStorageCard) == attrStorageCard)
                {
                    scards.Add(di.Name);
                }
            }
            return (string[])scards.ToArray(typeof(string));
        } 
    }
}