#region Using directives

using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices;
using System.IO;

#endregion

namespace SmallNotepad_CS
{
    /// <summary>
    /// Summary description for form.
    /// </summary>
    public class MainForm : System.Windows.Forms.Form
    {
        private MenuItem mnuFile;
        private TextBox txtEditor;
        private MenuItem mnuNew;
        private MenuItem mnuOpen;
        private MenuItem mnuSave;
        private MenuItem mnuSaveAs;
        private MenuItem mnuSep;
        private MenuItem mnuExit;
        private MenuItem mnuEdit;
        private MenuItem mnuFormat;
        private MenuItem mnuHelp;
        private Microsoft.WindowsCE.Forms.InputPanel SIP;
        private MenuItem mnuUndo;
        private MenuItem mnuCut;
        private MenuItem mnuCopy;
        private MenuItem mnuPaste;
        private MenuItem mnuDelete;
        /// <summary>
        /// Main menu for the form.
        /// </summary>
        private System.Windows.Forms.MainMenu mainMenu1;


        //   
        public const int WM_CUT = 0x0300;
        public const int WM_COPY = 0x0301;
        public const int WM_PASTE = 0x0302;
        public const int WM_CLEAR = 0x0303;
        private OpenFileDialog dlgOpenFile;
        private SaveFileDialog dlgSaveFile;
        private MenuItem mnuAbout;
        private ContextMenu contextMenu;
        private MenuItem cmenuUndo;
        private MenuItem cmenuCut;
        private MenuItem cmenuCopy;
        private MenuItem cmenuPaste;
        private MenuItem cmenuDelete;
        public const int WM_UNDO = 0x0304;

        //  API
        [DllImport("coredll.dll", CharSet = CharSet.Unicode)]
        public static extern IntPtr GetFocus();

        [DllImport("coredll.dll")]
        public static extern int SendMessage(IntPtr hWnd,
            uint Message, uint wParam, uint lParam);

        [DllImport("Coredll.dll")]
        private static extern bool IsClipboardFormatAvailable(uint uFormat);

        //    
        private const uint CF_UNICODETEXT = 13;
        
        string fname = "";
        bool flag = false;

        IntPtr hwndEditor;

        public MainForm()
        {
            InitializeComponent();
            #if DEBUG
                MinimizeBox = false;
            #else       
                MinimizeBox = true;
            #endif
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.mainMenu1 = new System.Windows.Forms.MainMenu();
            this.mnuFile = new System.Windows.Forms.MenuItem();
            this.mnuNew = new System.Windows.Forms.MenuItem();
            this.mnuOpen = new System.Windows.Forms.MenuItem();
            this.mnuSave = new System.Windows.Forms.MenuItem();
            this.mnuSaveAs = new System.Windows.Forms.MenuItem();
            this.mnuSep = new System.Windows.Forms.MenuItem();
            this.mnuExit = new System.Windows.Forms.MenuItem();
            this.mnuEdit = new System.Windows.Forms.MenuItem();
            this.mnuUndo = new System.Windows.Forms.MenuItem();
            this.mnuCut = new System.Windows.Forms.MenuItem();
            this.mnuCopy = new System.Windows.Forms.MenuItem();
            this.mnuPaste = new System.Windows.Forms.MenuItem();
            this.mnuDelete = new System.Windows.Forms.MenuItem();
            this.mnuFormat = new System.Windows.Forms.MenuItem();
            this.mnuHelp = new System.Windows.Forms.MenuItem();
            this.mnuAbout = new System.Windows.Forms.MenuItem();
            this.txtEditor = new System.Windows.Forms.TextBox();
            this.SIP = new Microsoft.WindowsCE.Forms.InputPanel();
            this.dlgOpenFile = new System.Windows.Forms.OpenFileDialog();
            this.dlgSaveFile = new System.Windows.Forms.SaveFileDialog();
            this.contextMenu = new System.Windows.Forms.ContextMenu();
            this.cmenuUndo = new System.Windows.Forms.MenuItem();
            this.cmenuCut = new System.Windows.Forms.MenuItem();
            this.cmenuCopy = new System.Windows.Forms.MenuItem();
            this.cmenuPaste = new System.Windows.Forms.MenuItem();
            this.cmenuDelete = new System.Windows.Forms.MenuItem();
            // 
            // mainMenu1
            // 
            this.mainMenu1.MenuItems.Add(this.mnuFile);
            this.mainMenu1.MenuItems.Add(this.mnuEdit);
            this.mainMenu1.MenuItems.Add(this.mnuFormat);
            this.mainMenu1.MenuItems.Add(this.mnuHelp);
            // 
            // mnuFile
            // 
            this.mnuFile.MenuItems.Add(this.mnuNew);
            this.mnuFile.MenuItems.Add(this.mnuOpen);
            this.mnuFile.MenuItems.Add(this.mnuSave);
            this.mnuFile.MenuItems.Add(this.mnuSaveAs);
            this.mnuFile.MenuItems.Add(this.mnuSep);
            this.mnuFile.MenuItems.Add(this.mnuExit);
            this.mnuFile.Text = "";
            // 
            // mnuNew
            // 
            this.mnuNew.Text = "";
            // 
            // mnuOpen
            // 
            this.mnuOpen.Text = "...";
            this.mnuOpen.Click += new System.EventHandler(this.mnuOpen_Click);
            // 
            // mnuSave
            // 
            this.mnuSave.Text = "";
            this.mnuSave.Click += new System.EventHandler(this.mnuSave_Click);
            // 
            // mnuSaveAs
            // 
            this.mnuSaveAs.Text = " ...";
            this.mnuSaveAs.Click += new System.EventHandler(this.mnuSaveAs_Click);
            // 
            // mnuSep
            // 
            this.mnuSep.Text = "-";
            // 
            // mnuExit
            // 
            this.mnuExit.Text = "";
            this.mnuExit.Click += new System.EventHandler(this.mnuExit_Click);
            // 
            // mnuEdit
            // 
            this.mnuEdit.MenuItems.Add(this.mnuUndo);
            this.mnuEdit.MenuItems.Add(this.mnuCut);
            this.mnuEdit.MenuItems.Add(this.mnuCopy);
            this.mnuEdit.MenuItems.Add(this.mnuPaste);
            this.mnuEdit.MenuItems.Add(this.mnuDelete);
            this.mnuEdit.Text = "";
            this.mnuEdit.Popup += new System.EventHandler(this.mnuEdit_Popup);
            // 
            // mnuUndo
            // 
            this.mnuUndo.Text = "";
            this.mnuUndo.Click += new System.EventHandler(this.mnuUndo_Click);
            // 
            // mnuCut
            // 
            this.mnuCut.Text = "";
            this.mnuCut.Click += new System.EventHandler(this.mnuCut_Click);
            // 
            // mnuCopy
            // 
            this.mnuCopy.Text = "";
            this.mnuCopy.Click += new System.EventHandler(this.mnuCopy_Click);
            // 
            // mnuPaste
            // 
            this.mnuPaste.Text = "";
            this.mnuPaste.Click += new System.EventHandler(this.mnuPaste_Click);
            // 
            // mnuDelete
            // 
            this.mnuDelete.Text = "";
            this.mnuDelete.Click += new System.EventHandler(this.mnuDelete_Click);
            // 
            // mnuFormat
            // 
            this.mnuFormat.Text = "";
            // 
            // mnuHelp
            // 
            this.mnuHelp.MenuItems.Add(this.mnuAbout);
            this.mnuHelp.Text = "";
            // 
            // mnuAbout
            // 
            this.mnuAbout.Text = " ";
            this.mnuAbout.Click += new System.EventHandler(this.mnuAbout_Click);
            // 
            // txtEditor
            // 
            this.txtEditor.ContextMenu = this.contextMenu;
            this.txtEditor.Location = new System.Drawing.Point(0, 0);
            this.txtEditor.Multiline = true;
            this.txtEditor.ScrollBars = System.Windows.Forms.ScrollBars.Both;
            this.txtEditor.Size = new System.Drawing.Size(237, 262);
            this.txtEditor.TextChanged += new System.EventHandler(this.txtEditor_TextChanged);
            // 
            // SIP
            // 
            this.SIP.EnabledChanged += new System.EventHandler(this.SIP_EnabledChanged);
            // 
            // dlgOpenFile
            // 
            this.dlgOpenFile.FileName = "openFileDialog1";
            // 
            // contextMenu
            // 
            this.contextMenu.MenuItems.Add(this.cmenuUndo);
            this.contextMenu.MenuItems.Add(this.cmenuCut);
            this.contextMenu.MenuItems.Add(this.cmenuCopy);
            this.contextMenu.MenuItems.Add(this.cmenuPaste);
            this.contextMenu.MenuItems.Add(this.cmenuDelete);
            this.contextMenu.Popup += new System.EventHandler(this.contextMenu_Popup);
            // 
            // cmenuUndo
            // 
            this.cmenuUndo.Text = "";
            this.cmenuUndo.Click += new System.EventHandler(this.cmenuUndo_Click);
            // 
            // cmenuCut
            // 
            this.cmenuCut.Text = "";
            this.cmenuCut.Click += new System.EventHandler(this.cmenuCut_Click);
            // 
            // cmenuCopy
            // 
            this.cmenuCopy.Text = "";
            this.cmenuCopy.Click += new System.EventHandler(this.cmenuCopy_Click);
            // 
            // cmenuPaste
            // 
            this.cmenuPaste.Text = "";
            this.cmenuPaste.Click += new System.EventHandler(this.cmenuPaste_Click);
            // 
            // cmenuDelete
            // 
            this.cmenuDelete.Text = "";
            this.cmenuDelete.Click += new System.EventHandler(this.cmenuDelete_Click);
            // 
            // MainForm
            // 
            this.ClientSize = new System.Drawing.Size(240, 268);
            this.Controls.Add(this.txtEditor);
            this.Menu = this.mainMenu1;
            this.Text = "";
            this.Load += new System.EventHandler(this.MainForm_Load);

        }

        #endregion

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        static void Main()
        {
            Application.Run(new MainForm());
        }

        private void mnuExit_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            //    
            txtEditor.Location = new Point(0, 0);
                        
            //       
            txtEditor.Width = this.Width;

            //        SIP
            //txtEditor.Height = this.Height;
            SetTextBoxHeight(); 
               
            //  
            txtEditor.Focus();

            //    
            hwndEditor = GetFocus();
            
        }

        //         SIP
        private void SetTextBoxHeight()
        {
            if (SIP.Enabled)
                txtEditor.Height = SIP.VisibleDesktop.Height + 2;
            else
                txtEditor.Height = this.Height;
        }

        private void SIP_EnabledChanged(object sender, EventArgs e)
        {
            SetTextBoxHeight();
        }

        private void mnuCut_Click(object sender, EventArgs e)
        {
            flag = true;
            //  
            SendMessage(hwndEditor, WM_CUT, 0, 0); 
        }

        private void mnuUndo_Click(object sender, EventArgs e)
        {
            //   
            SendMessage(hwndEditor, WM_UNDO, 0, 0);
        }

        private void mnuCopy_Click(object sender, EventArgs e)
        {
            //   
            SendMessage(hwndEditor, WM_COPY, 0, 0);
        }

        private void mnuPaste_Click(object sender, EventArgs e)
        {
            //     
            SendMessage(hwndEditor, WM_PASTE, 0, 0);
        }

        private void mnuDelete_Click(object sender, EventArgs e)
        {
            //   
            SendMessage(hwndEditor, WM_CLEAR, 0, 0);
        }

        public static bool IsText()
        {
            try
            {
                return IsClipboardFormatAvailable(CF_UNICODETEXT);
            }
            catch (Exception ex)
            {
                MessageBox.Show("  ,     !");
                return false;
            }
        }

        private void mnuEdit_Popup(object sender, EventArgs e)
        {
            //  
            if (txtEditor.SelectionLength > 0)
            {
                mnuCut.Enabled = true;
                mnuCopy.Enabled = true;
                mnuDelete.Enabled = true;
            }
                //    
            else
            {
                mnuCut.Enabled = false;
                mnuCopy.Enabled = false;
                mnuDelete.Enabled = false;
            }


            if (IsText())
                mnuPaste.Enabled = true;
            else
                mnuPaste.Enabled = false;

        }

        private void mnuOpen_Click(object sender, EventArgs e)
        {
            dlgOpenFile.Filter = "  (*.txt)|*.txt| |*.*";
            dlgOpenFile.ShowDialog();
            if (File.Exists(dlgOpenFile.FileName))
            {
                fname = dlgOpenFile.FileName;
                StreamReader sr = new StreamReader(fname, System.Text.Encoding.GetEncoding("Windows-1251"), false);
                txtEditor.Text = sr.ReadToEnd();
                flag = false;
                sr.Close();
            }	
        }

        private void mnuSaveAs_Click(object sender, EventArgs e)
        {
            SaveFileDialog dlgSaveFile = new SaveFileDialog();
            dlgSaveFile.Filter = "  (*.txt)|*.txt| |*.*";
            dlgSaveFile.ShowDialog();
            fname = dlgSaveFile.FileName;
            savedata();
        }

        private void savedata()
        {
            if (fname == "")
            {
                SaveFileDialog dlgSaveFile = new SaveFileDialog();
                dlgSaveFile.Filter = "  (*.txt)|*.txt| |*.*";
                DialogResult res = dlgSaveFile.ShowDialog();
                if (res == DialogResult.Cancel)
                {
                    return;
                }
                fname = dlgSaveFile.FileName;
                MessageBox.Show(fname);
            }
            
            StreamWriter sw = new StreamWriter(fname, false, System.Text.Encoding.GetEncoding("Windows-1251"));
            sw.WriteLine(txtEditor.Text);
            sw.Flush();
            sw.Close();
            flag = false;
        }

        private void mnuSave_Click(object sender, EventArgs e)
        {
            savedata();
        }

        private void txtEditor_TextChanged(object sender, EventArgs e)
        {
            flag = true;
        }

        private void mnuAbout_Click(object sender, EventArgs e)
        {
            AboutForm about = new AboutForm();
            about.ShowDialog();
        }

        private void cmenuUndo_Click(object sender, EventArgs e)
        {
            //   
            SendMessage(hwndEditor, WM_UNDO, 0, 0);
        }

        private void cmenuCut_Click(object sender, EventArgs e)
        {
            flag = true;
            //  
            SendMessage(hwndEditor, WM_CUT, 0, 0); 
        }

        private void cmenuCopy_Click(object sender, EventArgs e)
        {
            //   
            SendMessage(hwndEditor, WM_COPY, 0, 0);
        }

        private void cmenuPaste_Click(object sender, EventArgs e)
        {
            //     
            SendMessage(hwndEditor, WM_PASTE, 0, 0);
        }

        private void cmenuDelete_Click(object sender, EventArgs e)
        {
            //   
            SendMessage(hwndEditor, WM_CLEAR, 0, 0);
        }

        private void contextMenu_Popup(object sender, EventArgs e)
        {
            //  
            if (txtEditor.SelectionLength > 0)
            {
                cmenuCut.Enabled = true;
                cmenuCopy.Enabled = true;
                cmenuDelete.Enabled = true;
            }
            //    
            else
            {
                cmenuCut.Enabled = false;
                cmenuCopy.Enabled = false;
                cmenuDelete.Enabled = false;
            }


            if (IsText())
                cmenuPaste.Enabled = true;
            else
                cmenuPaste.Enabled = false;
        }

  


    }
}

