using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.WindowsCE.Forms;
using System.Runtime.InteropServices;

namespace InputMode_CS
{
    public partial class Form1 : Form
    {    
        [DllImport("coredll.dll", EntryPoint = "SendMessage")]
        private static extern uint SendMessage(IntPtr hWnd, uint msg, uint wParam,
          uint lParam);

        //    
        const uint EM_SETINPUTMODE = 0x00DE;
        
        //   
        public enum InputModeAPI
        {
            Spell = 0,
            T9 = 1,
            Numbers = 2,
            Text = 3
        }

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //     
            InputModeEditor.SetInputMode(txtName, InputMode.AlphaCurrent);

            //     
            InputModeEditor.SetInputMode(txtPhone, InputMode.Numeric);
        }

        public static void SetInputMode(Control ctrl, InputModeAPI mode)
        {
            SendMessage(ctrl.Handle, EM_SETINPUTMODE, 0, (uint)mode);
        }

        private void mnuT9_Click(object sender, EventArgs e)
        {
            SetInputMode(textBox3, InputModeAPI.T9);
        }

        private void mnuSpell_Click(object sender, EventArgs e)
        {
            SetInputMode(textBox3, InputModeAPI.Spell);
        }

        private void mnuNumeric_Click(object sender, EventArgs e)
        {
            SetInputMode(textBox3, InputModeAPI.Numbers);
        }

        private void mnuText_Click(object sender, EventArgs e)
        {
            SetInputMode(textBox3, InputModeAPI.Text);
        }

    }
}